/* Mostly compiled-in link scripts. Other scripts can be stored
   in the lib directory and invoked with command line switches */

/* emulate the original gld for the given i386aout
   Copyright (C) 1991, 1993 Free Software Foundation, Inc.
   Written by Steve Chamberlain steve@cygnus.com

This file is part of GLD, the Gnu Linker.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#define TARGET_IS_i386aout

#include "bfd.h"
#include "sysdep.h"
#include "bfdlink.h"

#include "ld.h"
#include "config.h"
#include "ldmain.h"
#include "ldemul.h"
#include "ldfile.h"
#include "ldmisc.h"

static void gldi386aout_before_parse PARAMS ((void));
static char *gldi386aout_get_script PARAMS ((int *isfile));

static void
gldi386aout_before_parse()
{
#ifndef TARGET_			/* I.e., if not generic.  */
  ldfile_output_architecture = bfd_arch_i386;
#endif /* not TARGET_ */
}

static char *
gldi386aout_get_script(isfile)
     int *isfile;
{			     
  *isfile = 0;

  if (link_info.relocateable == true && config.build_constructors == true)
    return
"OUTPUT_FORMAT(\"a.out-i386\")\n\
OUTPUT_ARCH(i386)\n\
SECTIONS\n\
{\n\
  .text :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
  }\n\
  .data   :\n\
  {\n\
    *(.data)\n\
    CONSTRUCTORS\n\
  }\n\
  .bss  :\n\
  {\n\
   ;\n\
   *(.bss)\n\
   *(COMMON)\n\
   ;\n\
   ;\n\
  }\n\
}\n\n"
  ; else if (link_info.relocateable == true) return
"OUTPUT_FORMAT(\"a.out-i386\")\n\
OUTPUT_ARCH(i386)\n\
SECTIONS\n\
{\n\
  .text :\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
  }\n\
  .data   :\n\
  {\n\
    *(.data)\n\
  }\n\
  .bss  :\n\
  {\n\
   ;\n\
   *(.bss)\n\
   *(COMMON)\n\
   ;\n\
   ;\n\
  }\n\
}\n\n"
  ; else if (!config.text_read_only) return
"OUTPUT_FORMAT(\"a.out-i386\")\n\
OUTPUT_ARCH(i386)\n\
SEARCH_DIR(/lib); SEARCH_DIR(/usr/lib); SEARCH_DIR(/usr/lib); SEARCH_DIR(/usr/local/lib/lcc); SEARCH_DIR(/usr/local/lib);\n\
__DYNAMIC  =  0;\n\
SECTIONS\n\
{\n\
  .text 0x100:\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
    _etext = .;\n\
    endtext = .;\n\
  }\n\
  .data  . :\n\
  {\n\
    *(.data)\n\
    CONSTRUCTORS\n\
    _edata  =  .;\n\
    enddata  =  .;\n\
  }\n\
  .bss SIZEOF(.data) + ADDR(.data) :\n\
  {\n\
    __bss_start = .;\n\
   *(.bss)\n\
   *(COMMON)\n\
   _end = ALIGN(4) ;\n\
   __end = ALIGN(4) ;\n\
   endbss = ALIGN(4) ;\n\
  }\n\
}\n\n"
  ; else if (!config.magic_demand_paged) return
"OUTPUT_FORMAT(\"a.out-i386\")\n\
OUTPUT_ARCH(i386)\n\
SEARCH_DIR(/lib); SEARCH_DIR(/usr/lib); SEARCH_DIR(/usr/lib); SEARCH_DIR(/usr/local/lib/lcc); SEARCH_DIR(/usr/local/lib);\n\
__DYNAMIC  =  0;\n\
SECTIONS\n\
{\n\
  .text 0x100:\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
    _etext = ALIGN(0x100);\n\
    endtext = ALIGN(0x100);\n\
  }\n\
  .data  ALIGN(0x100) :\n\
  {\n\
    *(.data)\n\
    CONSTRUCTORS\n\
    _edata  =  .;\n\
    enddata  =  .;\n\
  }\n\
  .bss SIZEOF(.data) + ADDR(.data) :\n\
  {\n\
    __bss_start = .;\n\
   *(.bss)\n\
   *(COMMON)\n\
   _end = ALIGN(4) ;\n\
   __end = ALIGN(4) ;\n\
   endbss = ALIGN(4) ;\n\
  }\n\
}\n\n"
  ; else return
"OUTPUT_FORMAT(\"a.out-i386\")\n\
OUTPUT_ARCH(i386)\n\
SEARCH_DIR(/lib); SEARCH_DIR(/usr/lib); SEARCH_DIR(/usr/lib); SEARCH_DIR(/usr/local/lib/lcc); SEARCH_DIR(/usr/local/lib);\n\
__DYNAMIC  =  0;\n\
SECTIONS\n\
{\n\
  .text 0:\n\
  {\n\
    CREATE_OBJECT_SYMBOLS\n\
    *(.text)\n\
    _etext = ALIGN(0x100);\n\
    endtext = ALIGN(0x100);\n\
  }\n\
  .data  ALIGN(0x100) :\n\
  {\n\
    *(.data)\n\
    CONSTRUCTORS\n\
    _edata  =  .;\n\
    enddata  =  .;\n\
  }\n\
  .bss SIZEOF(.data) + ADDR(.data) :\n\
  {\n\
    __bss_start = .;\n\
   *(.bss)\n\
   *(COMMON)\n\
   _end = ALIGN(4) ;\n\
   __end = ALIGN(4) ;\n\
   endbss = ALIGN(4) ;\n\
  }\n\
}\n\n"
; }

struct ld_emulation_xfer_struct ld_i386aout_emulation = 
{
  gldi386aout_before_parse,
  syslib_default,
  hll_default,
  after_parse_default,
  after_allocation_default,
  set_output_arch_default,
  ldemul_default_target,
  before_allocation_default,
  gldi386aout_get_script,
  "i386aout",
  "a.out-i386"
};
