/* By Terry R. McConnell for lcc port of minix libc */

/* This is a very quick and dirty implementation, just to get things
rolling. Writing a completely correct strtod is devilishly difficult
to get right - google David Gay and weep. */


#include	<stdio.h>
#include	<stdlib.h>
#include	<float.h>
#include        <limits.h>
#include	<errno.h>
#include	<math.h>

/* convert the prefix of p to double, ignoring any leading whitespace. store
a pointer to unconverted suffix in *pp, unless it is NULL. If the answer would
overflow, HUGE_VAL is returned with the proper sign; if the answer would
underflow, zero is returned. In either case errno is set to ERANGE */ 

double
my_strtod(const char *p, char **pp)
{
	char c;
	char *q;
	int sign = 1,i=0,k=0;
	double value = 0.0;
	int exp = 0;

	while(isspace(*p))p++;
	c = *p;
	if(c == '-'){
		sign = -1;
		p++;
	}
	if(c == '+')p++;
	if(c == '0')p++;
	while(*p == '0')p++;
	while((c=*p++)){
		switch(c) {
			case 'E': /* is it exponential or start of text ? */
			case 'e':
				k =  strtol(p,&q,10);
				if(q == p){p--;break;}
				p = q; /* first uncoverted char */
				break;
			case '.':
				exp = i;
				continue;
			case '0':
				value = 10.0*value;
				i++;
				continue;
			case '1':
				value = 10.0*value + 1.0;
				i++;
				continue;
			case '2':
				value = 10.0*value + 2.0;
				i++;
				continue;
			case '3':
				value = 10.0*value + 3.0;
				i++;
				continue;
			case '4':
				value = 10.0*value + 4.0;
				i++;
				continue;
			case '5':
				value = 10.0*value + 5.0;
				i++;
				continue;
			case '6':
				value = 10.0*value + 6.0;
				i++;
				continue;
			case '7':
				value = 10.0*value + 7.0;
				i++;
				continue;
			case '8':
				value = 10.0*value + 8.0;
				i++;
				continue;
			case '9':
				value = 10.0*value + 9.0;
				i++;
				continue;
			default: 
				p--;
				break;
		} 
		break;
	}
	if(pp)*pp = (char *)p;
	if(exp + k - 1< DBL_MIN_10_EXP){
		errno = ERANGE;
		return 0.0;
	}
	/* Should be exp + k - 1 */
	if(exp + k > DBL_MAX_10_EXP){
		errno = ERANGE;
		if(sign == -1)
			return (-1.0)*HUGE_VAL;
		else return HUGE_VAL;
	}
	while(i-- > exp)value *= 0.1;
	if(k>0)
		while(k-->0)
			value *= 10.0;
	else if(k < 0)
		while(k++<0)
			value *= 0.1;
	if(sign == -1) value = (-1.0)*value;
	return value;
}
